/*
 * exti.c
 *
 *  Created on: Jun 10, 2023
 *      Author: hussamaldean
 */
#include "exti.h"

#include "stm32f4xx.h"

volatile uint8_t pressed;


void PC13_EXTI_Init(void)
{
	/*Disable global interrupts*/
	__disable_irq();

	RCC->AHB1ENR |=RCC_AHB1ENR_GPIOCEN;

	GPIOC->MODER &= ~GPIO_MODER_MODE13;

	/*Enable clock access to syscnf*/

	RCC->APB2ENR|= RCC_APB2ENR_SYSCFGEN;

	/*Select PORTC for EXTI13*/
	SYSCFG->EXTICR[3] |= SYSCFG_EXTICR4_EXTI13_PC;

	/*Unmask EXTI13*/

	EXTI->IMR|=EXTI_IMR_IM13;

	/*Select falling edge*/

	EXTI->FTSR|= EXTI_FTSR_TR13;

	NVIC_EnableIRQ(EXTI15_10_IRQn);

	/*Enable global interrupts*/
	__enable_irq();
}

uint8_t button_Pressed()
{
	return pressed;
}

void clear_pressed()
{
	pressed=0;
}

void EXTI15_10_IRQHandler(void)
{
	if (EXTI->PR & EXTI_PR_PR13)
	{
		pressed=1;

		EXTI->PR|=EXTI_PR_PR13;
	}
}
